<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: UDP</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('d2/d11/group__udp.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">UDP<div class="ingroups"><a class="el" href="../../d0/d2d/group__api.html">API</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>This module includes functions that control UDP communication.  
<a href="#details">More...</a></p>
<div class="dynheader">
Collaboration diagram for UDP:</div>
<div class="dyncontent">
<center><table><tr><td><img src="../../d2/d11/group__udp.png" border="0" alt="" usemap="#d2_2d11_2group____udp"/>
<map name="d2_2d11_2group____udp" id="d2_2d11_2group____udp">
<area shape="rect" id="node2" href="../../d0/d2d/group__api.html" title="This module includes the application programming interface to the OpenThread stack. " alt="" coords="5,5,48,31"/>
</map>
</td></tr></table></center>
</div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d28/structotSockAddr.html">otSockAddr</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This structure represents an IPv6 socket address.  <a href="../../d3/d28/structotSockAddr.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This structure represents the local and peer IPv6 socket addresses.  <a href="../../dd/d76/structotMessageInfo.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a></td></tr>
<tr class="memdesc:"><td class="mdescLeft">&#160;</td><td class="mdescRight">This structure represents a UDP socket.  <a href="../../da/dfd/structotUdpSocket.html#details">More...</a><br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr class="memitem:ga966fff91ccb31448707035a32ae4fb76"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga966fff91ccb31448707035a32ae4fb76"></a>
typedef struct <a class="el" href="../../d3/d28/structotSockAddr.html">otSockAddr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#ga966fff91ccb31448707035a32ae4fb76">otSockAddr</a></td></tr>
<tr class="memdesc:ga966fff91ccb31448707035a32ae4fb76"><td class="mdescLeft">&#160;</td><td class="mdescRight">This structure represents an IPv6 socket address. <br /></td></tr>
<tr class="separator:ga966fff91ccb31448707035a32ae4fb76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga626382fa8118ffa6fed7d9dab7439a96"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga626382fa8118ffa6fed7d9dab7439a96"></a>
typedef struct <a class="el" href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#ga626382fa8118ffa6fed7d9dab7439a96">otMessageInfo</a></td></tr>
<tr class="memdesc:ga626382fa8118ffa6fed7d9dab7439a96"><td class="mdescLeft">&#160;</td><td class="mdescRight">This structure represents the local and peer IPv6 socket addresses. <br /></td></tr>
<tr class="separator:ga626382fa8118ffa6fed7d9dab7439a96"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gacff67ed83068976da50fdfd6efdeaa1f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="gacff67ed83068976da50fdfd6efdeaa1f"></a>
typedef void(*&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#gacff67ed83068976da50fdfd6efdeaa1f">otUdpReceive</a>) (void *aContext, <a class="el" href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a> aMessage, const <a class="el" href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a> *aMessageInfo)</td></tr>
<tr class="memdesc:gacff67ed83068976da50fdfd6efdeaa1f"><td class="mdescLeft">&#160;</td><td class="mdescRight">This callback allows OpenThread to inform the application of a received UDP message. <br /></td></tr>
<tr class="separator:gacff67ed83068976da50fdfd6efdeaa1f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2d245018891da475518da5c375beeba7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ga2d245018891da475518da5c375beeba7"></a>
typedef struct <a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#ga2d245018891da475518da5c375beeba7">otUdpSocket</a></td></tr>
<tr class="memdesc:ga2d245018891da475518da5c375beeba7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This structure represents a UDP socket. <br /></td></tr>
<tr class="separator:ga2d245018891da475518da5c375beeba7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga830b1fac9ad667bbedc0e68da91e70aa"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#ga830b1fac9ad667bbedc0e68da91e70aa">otNewUdpMessage</a> (<a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *aInstance)</td></tr>
<tr class="memdesc:ga830b1fac9ad667bbedc0e68da91e70aa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Allocate a new message buffer for sending a UDP message.  <a href="#ga830b1fac9ad667bbedc0e68da91e70aa">More...</a><br /></td></tr>
<tr class="separator:ga830b1fac9ad667bbedc0e68da91e70aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa44b7d374d87e6f3624c275913676954"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#gaa44b7d374d87e6f3624c275913676954">otOpenUdpSocket</a> (<a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *aInstance, <a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a> *aSocket, <a class="el" href="../../d2/d11/group__udp.html#gacff67ed83068976da50fdfd6efdeaa1f">otUdpReceive</a> aCallback, void *aContext)</td></tr>
<tr class="memdesc:gaa44b7d374d87e6f3624c275913676954"><td class="mdescLeft">&#160;</td><td class="mdescRight">Open a UDP/IPv6 socket.  <a href="#gaa44b7d374d87e6f3624c275913676954">More...</a><br /></td></tr>
<tr class="separator:gaa44b7d374d87e6f3624c275913676954"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2957568d7098fc442abaadad77daabee"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#ga2957568d7098fc442abaadad77daabee">otCloseUdpSocket</a> (<a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a> *aSocket)</td></tr>
<tr class="memdesc:ga2957568d7098fc442abaadad77daabee"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close a UDP/IPv6 socket.  <a href="#ga2957568d7098fc442abaadad77daabee">More...</a><br /></td></tr>
<tr class="separator:ga2957568d7098fc442abaadad77daabee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gabbff7369b8794d597a5afd188e171ec0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#gabbff7369b8794d597a5afd188e171ec0">otBindUdpSocket</a> (<a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a> *aSocket, <a class="el" href="../../d3/d28/structotSockAddr.html">otSockAddr</a> *aSockName)</td></tr>
<tr class="memdesc:gabbff7369b8794d597a5afd188e171ec0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Bind a UDP/IPv6 socket.  <a href="#gabbff7369b8794d597a5afd188e171ec0">More...</a><br /></td></tr>
<tr class="separator:gabbff7369b8794d597a5afd188e171ec0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaafd3057272c0b42c69aa7d35956f5c92"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#gaafd3057272c0b42c69aa7d35956f5c92">otSendUdp</a> (<a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a> *aSocket, <a class="el" href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a> aMessage, const <a class="el" href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a> *aMessageInfo)</td></tr>
<tr class="memdesc:gaafd3057272c0b42c69aa7d35956f5c92"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a UDP/IPv6 message.  <a href="#gaafd3057272c0b42c69aa7d35956f5c92">More...</a><br /></td></tr>
<tr class="separator:gaafd3057272c0b42c69aa7d35956f5c92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4198c5e5356efec22801439076076a9f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#ga4198c5e5356efec22801439076076a9f">otSendDiagnosticGet</a> (<a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *aInstance, const <a class="el" href="../../d6/d55/structotIp6Address.html">otIp6Address</a> *aDestination, const uint8_t aTlvTypes[], uint8_t aCount)</td></tr>
<tr class="memdesc:ga4198c5e5356efec22801439076076a9f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a Network Diagnostic Get request.  <a href="#ga4198c5e5356efec22801439076076a9f">More...</a><br /></td></tr>
<tr class="separator:ga4198c5e5356efec22801439076076a9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6f3d90ff7fcd39b3767b1ebc8eb58e1a"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d11/group__udp.html#ga6f3d90ff7fcd39b3767b1ebc8eb58e1a">otSendDiagnosticReset</a> (<a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *aInstance, const <a class="el" href="../../d6/d55/structotIp6Address.html">otIp6Address</a> *aDestination, const uint8_t aTlvTypes[], uint8_t aCount)</td></tr>
<tr class="memdesc:ga6f3d90ff7fcd39b3767b1ebc8eb58e1a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send a Network Diagnostic Reset request.  <a href="#ga6f3d90ff7fcd39b3767b1ebc8eb58e1a">More...</a><br /></td></tr>
<tr class="separator:ga6f3d90ff7fcd39b3767b1ebc8eb58e1a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>This module includes functions that control UDP communication. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="gabbff7369b8794d597a5afd188e171ec0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> otBindUdpSocket </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a> *&#160;</td>
          <td class="paramname"><em>aSocket</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d3/d28/structotSockAddr.html">otSockAddr</a> *&#160;</td>
          <td class="paramname"><em>aSockName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Bind a UDP/IPv6 socket. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aSocket</td><td>A pointer to a UDP socket structure. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aSockName</td><td>A pointer to an IPv6 socket address structure.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadErrorNone</td><td>Bind operation was successful.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="../../d2/d11/group__udp.html#ga830b1fac9ad667bbedc0e68da91e70aa" title="Allocate a new message buffer for sending a UDP message. ">otNewUdpMessage</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gaa44b7d374d87e6f3624c275913676954" title="Open a UDP/IPv6 socket. ">otOpenUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#ga2957568d7098fc442abaadad77daabee" title="Close a UDP/IPv6 socket. ">otCloseUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gaafd3057272c0b42c69aa7d35956f5c92" title="Send a UDP/IPv6 message. ">otSendUdp</a> </dd></dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_gabbff7369b8794d597a5afd188e171ec0_icgraph.png" border="0" usemap="#d2/d11/group__udp_gabbff7369b8794d597a5afd188e171ec0_icgraph" alt=""/></div>
<map name="d2/d11/group__udp_gabbff7369b8794d597a5afd188e171ec0_icgraph" id="d2/d11/group__udp_gabbff7369b8794d597a5afd188e171ec0_icgraph">
<area shape="rect" id="node2" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#ab23c737fe108c24331f40d024d5f446a" title="This method starts the CLI server. " alt="" coords="178,5,332,31"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ga2957568d7098fc442abaadad77daabee"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> otCloseUdpSocket </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a> *&#160;</td>
          <td class="paramname"><em>aSocket</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Close a UDP/IPv6 socket. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aSocket</td><td>A pointer to a UDP socket structure.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadErrorNone</td><td>Successfully closed the socket.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="../../d2/d11/group__udp.html#ga830b1fac9ad667bbedc0e68da91e70aa" title="Allocate a new message buffer for sending a UDP message. ">otNewUdpMessage</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gaa44b7d374d87e6f3624c275913676954" title="Open a UDP/IPv6 socket. ">otOpenUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gabbff7369b8794d597a5afd188e171ec0" title="Bind a UDP/IPv6 socket. ">otBindUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gaafd3057272c0b42c69aa7d35956f5c92" title="Send a UDP/IPv6 message. ">otSendUdp</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga830b1fac9ad667bbedc0e68da91e70aa"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a> otNewUdpMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *&#160;</td>
          <td class="paramname"><em>aInstance</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Allocate a new message buffer for sending a UDP message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aInstance</td><td>A pointer to an OpenThread instance.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the message buffer or NULL if no message buffers are available.</dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="../../d4/d7c/group__messages.html#ga538d36d69a14bd432d651e062070bc06" title="Free an allocated message buffer. ">otFreeMessage</a> </dd></dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_ga830b1fac9ad667bbedc0e68da91e70aa_cgraph.png" border="0" usemap="#d2/d11/group__udp_ga830b1fac9ad667bbedc0e68da91e70aa_cgraph" alt=""/></div>
<map name="d2/d11/group__udp_ga830b1fac9ad667bbedc0e68da91e70aa_cgraph" id="d2/d11/group__udp_ga830b1fac9ad667bbedc0e68da91e70aa_cgraph">
<area shape="rect" id="node2" href="../../de/ded/classThread_1_1Ip6_1_1Udp.html#afe746fb2f5c83a97c20e54fdb9c595a3" title="This method returns a new UDP message with sufficient header space reserved. " alt="" coords="191,68,401,93"/>
<area shape="rect" id="node3" href="../../d3/d05/classThread_1_1Ip6_1_1Ip6.html#a215eeb84e75972828efbc163eedc1ec5" title="This method allocates a new message buffer from the buffer pool. " alt="" coords="449,68,652,93"/>
<area shape="rect" id="node4" href="../../d5/d9f/classThread_1_1MessagePool.html#a2d10b04dfeb1e0c9321eab0e95fda55f" title="This method is used to obtain a new message. " alt="" coords="700,68,886,93"/>
<area shape="rect" id="node5" href="../../dc/d3c/classThread_1_1Message.html#a942818bf261c0af93b793017407c2b2c" title="This method sets whether or not link security is enabled for the message. " alt="" coords="942,5,1119,44"/>
<area shape="rect" id="node6" href="../../dc/d3c/classThread_1_1Message.html#acecf07ee065974c8b211c151ea5d6e14" title="This method sets the number of bytes in the message. " alt="" coords="934,68,1127,93"/>
<area shape="rect" id="node7" href="../../d5/d9f/classThread_1_1MessagePool.html#a80238d94036455e30762ea4a5a0916f8" title="This method is used to free a message and return all message buffers to the buffer pool..." alt="" coords="955,117,1107,156"/>
<area shape="rect" id="node8" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="1175,99,1373,124"/>
<area shape="rect" id="node9" href="../../db/d50/classThread_1_1Buffer.html#a437ec9ccafa1ef6040a6e8e4fae9c3ca" title="This method sets the pointer to the next message buffer. " alt="" coords="1176,148,1373,173"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_ga830b1fac9ad667bbedc0e68da91e70aa_icgraph.png" border="0" usemap="#d2/d11/group__udp_ga830b1fac9ad667bbedc0e68da91e70aa_icgraph" alt=""/></div>
<map name="d2/d11/group__udp_ga830b1fac9ad667bbedc0e68da91e70aa_icgraph" id="d2/d11/group__udp_ga830b1fac9ad667bbedc0e68da91e70aa_icgraph">
<area shape="rect" id="node2" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#a50e5829bd74bf2845d8313575e2dd15c" title="This method delivers raw characters to the client. " alt="" coords="191,12,357,37"/>
<area shape="rect" id="node3" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#ab8ac2489d2049ef5880c77ac1cdc639f" title="This method delivers formatted output to the client. " alt="" coords="405,5,571,44"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="gaa44b7d374d87e6f3624c275913676954"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> otOpenUdpSocket </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *&#160;</td>
          <td class="paramname"><em>aInstance</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a> *&#160;</td>
          <td class="paramname"><em>aSocket</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d2/d11/group__udp.html#gacff67ed83068976da50fdfd6efdeaa1f">otUdpReceive</a>&#160;</td>
          <td class="paramname"><em>aCallback</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>aContext</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Open a UDP/IPv6 socket. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aInstance</td><td>A pointer to an OpenThread instance. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aSocket</td><td>A pointer to a UDP socket structure. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aCallback</td><td>A pointer to the application callback function. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aContext</td><td>A pointer to application-specific context.</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadErrorNone</td><td>Successfully opened the socket. </td></tr>
    <tr><td class="paramname">kThreadErrorInvalidArgs</td><td>Given socket structure was already opened.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="../../d2/d11/group__udp.html#ga830b1fac9ad667bbedc0e68da91e70aa" title="Allocate a new message buffer for sending a UDP message. ">otNewUdpMessage</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#ga2957568d7098fc442abaadad77daabee" title="Close a UDP/IPv6 socket. ">otCloseUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gabbff7369b8794d597a5afd188e171ec0" title="Bind a UDP/IPv6 socket. ">otBindUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gaafd3057272c0b42c69aa7d35956f5c92" title="Send a UDP/IPv6 message. ">otSendUdp</a> </dd></dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_gaa44b7d374d87e6f3624c275913676954_icgraph.png" border="0" usemap="#d2/d11/group__udp_gaa44b7d374d87e6f3624c275913676954_icgraph" alt=""/></div>
<map name="d2/d11/group__udp_gaa44b7d374d87e6f3624c275913676954_icgraph" id="d2/d11/group__udp_gaa44b7d374d87e6f3624c275913676954_icgraph">
<area shape="rect" id="node2" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#ab23c737fe108c24331f40d024d5f446a" title="This method starts the CLI server. " alt="" coords="184,5,338,31"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ga4198c5e5356efec22801439076076a9f"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> otSendDiagnosticGet </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *&#160;</td>
          <td class="paramname"><em>aInstance</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="../../d6/d55/structotIp6Address.html">otIp6Address</a> *&#160;</td>
          <td class="paramname"><em>aDestination</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t&#160;</td>
          <td class="paramname"><em>aTlvTypes</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aCount</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a Network Diagnostic Get request. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aDestination</td><td>A pointer to destination address. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aTlvTypes</td><td>An array of Network Diagnostic TLV types. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aCount</td><td>Number of types in aTlvTypes </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_ga4198c5e5356efec22801439076076a9f_cgraph.png" border="0" usemap="#d2/d11/group__udp_ga4198c5e5356efec22801439076076a9f_cgraph" alt=""/></div>
<map name="d2/d11/group__udp_ga4198c5e5356efec22801439076076a9f_cgraph" id="d2/d11/group__udp_ga4198c5e5356efec22801439076076a9f_cgraph">
<area shape="rect" id="node2" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a51609995a6e04a1aac273e430af4f53f" title="This method returns a pointer to the network diagnostic object. " alt="" coords="251,700,412,739"/>
<area shape="rect" id="node3" href="../../d6/d17/classThread_1_1NetworkDiagnostic_1_1NetworkDiagnostic.html#abc624ac04ecaf17b1b738a475e5b0d6a" title="This method sends Diagnostic Get request. " alt="" coords="201,763,463,801"/>
<area shape="rect" id="node4" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#aaa9112c22813ceb55338050f0365c598" title="This method opens the UDP socket. " alt="" coords="521,5,683,44"/>
<area shape="rect" id="node5" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#aa07479b557c551452986ff7a0ce20773" title="This method binds the UDP socket. " alt="" coords="521,68,683,107"/>
<area shape="rect" id="node6" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#aafb4481c92d1f8515e51cfa822a1bde1" title="This method returns a new UDP message with sufficient header space reserved. " alt="" coords="521,131,683,169"/>
<area shape="rect" id="node7" href="../../dd/d10/group__random.html#gaa20820ca4e6e1ce8cd47ded9762b14ca" title="Get a 32&#45;bit random value. " alt="" coords="539,193,666,219"/>
<area shape="rect" id="node8" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ad221953768fdb61bd62fa1bc3ffd4c89" title="This method initializes the CoAP header. " alt="" coords="525,243,679,281"/>
<area shape="rect" id="node10" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ad4147a19a4e8861f321c8aaaa5db6baa" title="This method sets the Type value. " alt="" coords="525,305,679,344"/>
<area shape="rect" id="node11" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a0a2c1cf0ff97aab363e71f716254a736" title="This method sets the Code value. " alt="" coords="525,368,679,407"/>
<area shape="rect" id="node12" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a7a374b4bd31694216d9397e1409209a0" title="This method sets the Message ID value. " alt="" coords="525,431,679,469"/>
<area shape="rect" id="node13" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a9d8d2a7b438e4a7d27ce3b979b0bb2a0" title="This method sets the Token value and length. " alt="" coords="525,493,679,532"/>
<area shape="rect" id="node14" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a1df234ef27c9000081fbbe24e7c97dd6" title="This method appends a Uri&#45;Path option. " alt="" coords="520,556,685,595"/>
<area shape="rect" id="node16" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#aecbcbb8b836e0283559b89bd64fbc47f" title="This method terminates the CoAP header. " alt="" coords="525,619,679,657"/>
<area shape="rect" id="node17" href="../../dc/d3c/classThread_1_1Message.html#a3c3d1c48e940f2553586d16e1618277d" title="This method appends bytes to the end of the message. " alt="" coords="513,681,692,707"/>
<area shape="rect" id="node18" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a5259ece3cbe8e332599f7de4c488ad32" title="This method returns a pointer to the first byte of the header. " alt="" coords="525,731,679,769"/>
<area shape="rect" id="node19" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ae1679d627108d5381dc1ae45d2254299" title="This method returns the header length in bytes. " alt="" coords="525,793,679,832"/>
<area shape="rect" id="node20" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html#a794b87e17aa877f3551c00aa8c892072" title="This method returns a reference to the peer socket address. " alt="" coords="516,856,689,895"/>
<area shape="rect" id="node21" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html#a97e94677a677f600a227dd970f4a02e8" title="This method returns a reference to the local socket address. " alt="" coords="752,669,926,708"/>
<area shape="rect" id="node22" href="../../df/d94/group__core-mle-core.html#gae4cc6a5939309cfc729293345142a15a" title="This method returns a pointer to the RLOC assigned to the Thread interface. " alt="" coords="511,919,694,957"/>
<area shape="rect" id="node24" href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html#a6c8c4f1757a98e7a45197c97da1ec8b8" title="This method returns the network interface identifier. " alt="" coords="540,1033,664,1072"/>
<area shape="rect" id="node25" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#ac4fb0ea0ae514fa0edfeaa91dfbdabca" title="This method sends a UDP message. " alt="" coords="521,1096,683,1135"/>
<area shape="rect" id="node36" href="../../dc/d3c/classThread_1_1Message.html#adc9d723284f5807d9c272ab89bc52b45" title="This method frees this message buffer. " alt="" coords="522,1159,682,1184"/>
<area shape="rect" id="node37" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a134a9321fd50bc3cc6c2e7a8d313ed23" title="This method parses the CoAP header from a message. " alt="" coords="525,1235,679,1273"/>
<area shape="rect" id="node42" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a552cf5eab882b244b178b8093e8a18e9" title="This method returns the Token length. " alt="" coords="762,1480,916,1519"/>
<area shape="rect" id="node43" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a0d72d5dcded14ce9da3678a456cb70a8" title="This method returns the Type value. " alt="" coords="525,1349,679,1388"/>
<area shape="rect" id="node44" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a08454fc48790efe33c95be2311e1e6d1" title="This method returns the Code value. " alt="" coords="525,1412,679,1451"/>
<area shape="rect" id="node45" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ad45e8b7c304fce8c896ef531be34e9d6" title="This method returns the Message ID value. " alt="" coords="525,1475,679,1513"/>
<area shape="rect" id="node46" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ad51db46720122c64e67143e10eaf3820" title="This method returns a pointer to the Token value. " alt="" coords="525,1537,679,1576"/>
<area shape="rect" id="node9" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a411c64839fe9cf63ac201f9a6760199c" title="This method sets the Version value. " alt="" coords="762,243,916,281"/>
<area shape="rect" id="node15" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ac047d4a2285b8315c1f11d66c04994a4" title="This method appends a CoAP option. " alt="" coords="762,544,916,583"/>
<area shape="rect" id="node23" href="../../d9/d13/classThread_1_1Ip6_1_1NetifUnicastAddress.html#a2bb426bd29e271bd1fc09b61d1044911" title="This method returns the unicast address. " alt="" coords="755,607,924,645"/>
<area shape="rect" id="node26" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#a51cfd76548da9f661a0d7a47a8d5e813" title="This method indicates whether or not the IPv6 address is the Unspecified Address. ..." alt="" coords="766,732,912,771"/>
<area shape="rect" id="node27" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#a4c3b5b3798c5a209d94f145dd9f08424" title="This method returns the local socket address. " alt="" coords="758,795,920,833"/>
<area shape="rect" id="node28" href="../../d2/d7a/classThread_1_1Ip6_1_1SockAddr.html#a9f92ec4fbccf1d095aa8a43dd882dd2f" title="This method returns a reference to the IPv6 address. " alt="" coords="762,857,916,896"/>
<area shape="rect" id="node29" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#a3e48adfe7fb163bd8dd6e6f26cb5dda4" title="This method sets the UDP Source Port. " alt="" coords="757,920,922,959"/>
<area shape="rect" id="node30" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#aa6b4ee310b27450ea21696b8a1ab9e36" title="This method sets the UDP Destination Port. " alt="" coords="757,983,922,1021"/>
<area shape="rect" id="node31" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#a232ac624d1b666065516cd2b7dc5f729" title="This method sets the UDP Length. " alt="" coords="757,1045,922,1084"/>
<area shape="rect" id="node32" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9" title="This method returns the number of bytes in the message. " alt="" coords="742,1269,936,1295"/>
<area shape="rect" id="node33" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#ada31b17064f026a602cac8ce755cffcf" title="This method sets the UDP Checksum. " alt="" coords="757,1108,922,1147"/>
<area shape="rect" id="node34" href="../../dc/d3c/classThread_1_1Message.html#a9c900e4c1ddbb44f1d9c87d10172f63a" title="This method prepends bytes to the front of the message. " alt="" coords="748,1171,931,1196"/>
<area shape="rect" id="node35" href="../../dc/d3c/classThread_1_1Message.html#acaa6ed0d0c060a524cb5da25451acc0d" title="This method sets the byte offset within the message. " alt="" coords="745,1220,933,1245"/>
<area shape="rect" id="node38" href="../../dc/d3c/classThread_1_1Message.html#ac8304ee00c9e0b303539687e98e192e0" title="This method returns the byte offset within the message. " alt="" coords="744,1319,934,1344"/>
<area shape="rect" id="node39" href="../../dc/d3c/classThread_1_1Message.html#a76033bbc15170d72452186058defafa2" title="This method reads bytes from the message. " alt="" coords="757,1368,921,1393"/>
<area shape="rect" id="node41" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ad72a44d4abf73228b4857b9ad90e7465" title="This method returns the Version value. " alt="" coords="762,1417,916,1456"/>
<area shape="rect" id="node40" href="../../db/d50/classThread_1_1Buffer.html#a34ab22941ccd9bb222d251a6a18c95bf" title="This method returns a pointer to the next message buffer. " alt="" coords="984,1368,1182,1393"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_ga4198c5e5356efec22801439076076a9f_icgraph.png" border="0" usemap="#d2/d11/group__udp_ga4198c5e5356efec22801439076076a9f_icgraph" alt=""/></div>
<map name="d2/d11/group__udp_ga4198c5e5356efec22801439076076a9f_icgraph" id="d2/d11/group__udp_ga4198c5e5356efec22801439076076a9f_icgraph">
<area shape="rect" id="node2" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#ac3a6d19e1230529b3970e31ca7324373" title="This method interprets a CLI command. " alt="" coords="201,61,356,100"/>
<area shape="rect" id="node3" href="../../dd/dce/classThread_1_1Cli_1_1Console.html#ab5454035d54e21e0e780335eddf7ca7d" title="This method sets a callback that is called when console has some output. " alt="" coords="410,5,553,44"/>
<area shape="rect" id="node4" href="../../db/def/group__uart.html#ga2aec94bad212a6bd72bc82fe310eaca2" title="The UART driver calls this method to notify OpenThread that bytes have been received. " alt="" coords="413,68,549,93"/>
<area shape="rect" id="node5" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#ab23c737fe108c24331f40d024d5f446a" title="This method starts the CLI server. " alt="" coords="404,117,558,143"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="ga6f3d90ff7fcd39b3767b1ebc8eb58e1a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> otSendDiagnosticReset </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../d2/d83/structotInstance.html">otInstance</a> *&#160;</td>
          <td class="paramname"><em>aInstance</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="../../d6/d55/structotIp6Address.html">otIp6Address</a> *&#160;</td>
          <td class="paramname"><em>aDestination</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const uint8_t&#160;</td>
          <td class="paramname"><em>aTlvTypes</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aCount</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a Network Diagnostic Reset request. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aInstance</td><td>A pointer to an OpenThread instance. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aDestination</td><td>A pointer to destination address. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aTlvTypes</td><td>An array of Network Diagnostic TLV types. Currently only Type 9 is allowed. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aCount</td><td>Number of types in aTlvTypes </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_ga6f3d90ff7fcd39b3767b1ebc8eb58e1a_cgraph.png" border="0" usemap="#d2/d11/group__udp_ga6f3d90ff7fcd39b3767b1ebc8eb58e1a_cgraph" alt=""/></div>
<map name="d2/d11/group__udp_ga6f3d90ff7fcd39b3767b1ebc8eb58e1a_cgraph" id="d2/d11/group__udp_ga6f3d90ff7fcd39b3767b1ebc8eb58e1a_cgraph">
<area shape="rect" id="node2" href="../../d3/d8e/classThread_1_1ThreadNetif.html#a51609995a6e04a1aac273e430af4f53f" title="This method returns a pointer to the network diagnostic object. " alt="" coords="271,525,432,564"/>
<area shape="rect" id="node3" href="../../d6/d17/classThread_1_1NetworkDiagnostic_1_1NetworkDiagnostic.html#a0777620633e36db7a9bafe8654019d92" title="This method sends Diagnostic Reset request. " alt="" coords="214,588,490,627"/>
<area shape="rect" id="node4" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#aaa9112c22813ceb55338050f0365c598" title="This method opens the UDP socket. " alt="" coords="548,5,710,44"/>
<area shape="rect" id="node5" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#aa07479b557c551452986ff7a0ce20773" title="This method binds the UDP socket. " alt="" coords="548,68,710,107"/>
<area shape="rect" id="node6" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#aafb4481c92d1f8515e51cfa822a1bde1" title="This method returns a new UDP message with sufficient header space reserved. " alt="" coords="548,131,710,169"/>
<area shape="rect" id="node7" href="../../dd/d10/group__random.html#gaa20820ca4e6e1ce8cd47ded9762b14ca" title="Get a 32&#45;bit random value. " alt="" coords="565,193,693,219"/>
<area shape="rect" id="node8" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ad221953768fdb61bd62fa1bc3ffd4c89" title="This method initializes the CoAP header. " alt="" coords="552,243,706,281"/>
<area shape="rect" id="node10" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ad4147a19a4e8861f321c8aaaa5db6baa" title="This method sets the Type value. " alt="" coords="552,305,706,344"/>
<area shape="rect" id="node11" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a0a2c1cf0ff97aab363e71f716254a736" title="This method sets the Code value. " alt="" coords="552,368,706,407"/>
<area shape="rect" id="node12" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a7a374b4bd31694216d9397e1409209a0" title="This method sets the Message ID value. " alt="" coords="552,431,706,469"/>
<area shape="rect" id="node13" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a9d8d2a7b438e4a7d27ce3b979b0bb2a0" title="This method sets the Token value and length. " alt="" coords="552,493,706,532"/>
<area shape="rect" id="node14" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a1df234ef27c9000081fbbe24e7c97dd6" title="This method appends a Uri&#45;Path option. " alt="" coords="546,556,712,595"/>
<area shape="rect" id="node16" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#aecbcbb8b836e0283559b89bd64fbc47f" title="This method terminates the CoAP header. " alt="" coords="552,619,706,657"/>
<area shape="rect" id="node17" href="../../dc/d3c/classThread_1_1Message.html#a3c3d1c48e940f2553586d16e1618277d" title="This method appends bytes to the end of the message. " alt="" coords="540,681,718,707"/>
<area shape="rect" id="node18" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a5259ece3cbe8e332599f7de4c488ad32" title="This method returns a pointer to the first byte of the header. " alt="" coords="552,731,706,769"/>
<area shape="rect" id="node19" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ae1679d627108d5381dc1ae45d2254299" title="This method returns the header length in bytes. " alt="" coords="552,793,706,832"/>
<area shape="rect" id="node20" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html#a794b87e17aa877f3551c00aa8c892072" title="This method returns a reference to the peer socket address. " alt="" coords="542,856,716,895"/>
<area shape="rect" id="node21" href="../../da/d46/classThread_1_1Ip6_1_1MessageInfo.html#a97e94677a677f600a227dd970f4a02e8" title="This method returns a reference to the local socket address. " alt="" coords="779,927,952,965"/>
<area shape="rect" id="node22" href="../../df/d94/group__core-mle-core.html#gae4cc6a5939309cfc729293345142a15a" title="This method returns a pointer to the RLOC assigned to the Thread interface. " alt="" coords="538,919,720,957"/>
<area shape="rect" id="node24" href="../../d2/d55/classThread_1_1Ip6_1_1Netif.html#a6c8c4f1757a98e7a45197c97da1ec8b8" title="This method returns the network interface identifier. " alt="" coords="567,1033,691,1072"/>
<area shape="rect" id="node25" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#ac4fb0ea0ae514fa0edfeaa91dfbdabca" title="This method sends a UDP message. " alt="" coords="548,1144,710,1183"/>
<area shape="rect" id="node36" href="../../dc/d3c/classThread_1_1Message.html#adc9d723284f5807d9c272ab89bc52b45" title="This method frees this message buffer. " alt="" coords="549,1207,709,1232"/>
<area shape="rect" id="node9" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#a411c64839fe9cf63ac201f9a6760199c" title="This method sets the Version value. " alt="" coords="789,243,943,281"/>
<area shape="rect" id="node15" href="../../d0/d7f/classThread_1_1Coap_1_1Header.html#ac047d4a2285b8315c1f11d66c04994a4" title="This method appends a CoAP option. " alt="" coords="789,556,943,595"/>
<area shape="rect" id="node23" href="../../d9/d13/classThread_1_1Ip6_1_1NetifUnicastAddress.html#a2bb426bd29e271bd1fc09b61d1044911" title="This method returns the unicast address. " alt="" coords="781,864,950,903"/>
<area shape="rect" id="node26" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html#a51cfd76548da9f661a0d7a47a8d5e813" title="This method indicates whether or not the IPv6 address is the Unspecified Address. ..." alt="" coords="793,1200,939,1239"/>
<area shape="rect" id="node27" href="../../dc/d75/classThread_1_1Ip6_1_1UdpSocket.html#a4c3b5b3798c5a209d94f145dd9f08424" title="This method returns the local socket address. " alt="" coords="785,1263,947,1301"/>
<area shape="rect" id="node28" href="../../d2/d7a/classThread_1_1Ip6_1_1SockAddr.html#a9f92ec4fbccf1d095aa8a43dd882dd2f" title="This method returns a reference to the IPv6 address. " alt="" coords="788,1325,943,1364"/>
<area shape="rect" id="node29" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#a3e48adfe7fb163bd8dd6e6f26cb5dda4" title="This method sets the UDP Source Port. " alt="" coords="783,1388,948,1427"/>
<area shape="rect" id="node30" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#aa6b4ee310b27450ea21696b8a1ab9e36" title="This method sets the UDP Destination Port. " alt="" coords="783,1451,948,1489"/>
<area shape="rect" id="node31" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#a232ac624d1b666065516cd2b7dc5f729" title="This method sets the UDP Length. " alt="" coords="783,1513,948,1552"/>
<area shape="rect" id="node32" href="../../dc/d3c/classThread_1_1Message.html#a2cf440376e834030c38bb2ced4ca49e9" title="This method returns the number of bytes in the message. " alt="" coords="768,989,963,1015"/>
<area shape="rect" id="node33" href="../../d7/dd3/classThread_1_1Ip6_1_1UdpHeader.html#ada31b17064f026a602cac8ce755cffcf" title="This method sets the UDP Checksum. " alt="" coords="783,1039,948,1077"/>
<area shape="rect" id="node34" href="../../dc/d3c/classThread_1_1Message.html#a9c900e4c1ddbb44f1d9c87d10172f63a" title="This method prepends bytes to the front of the message. " alt="" coords="774,1101,957,1127"/>
<area shape="rect" id="node35" href="../../dc/d3c/classThread_1_1Message.html#acaa6ed0d0c060a524cb5da25451acc0d" title="This method sets the byte offset within the message. " alt="" coords="772,1151,960,1176"/>
</map>
</div>
</p>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_ga6f3d90ff7fcd39b3767b1ebc8eb58e1a_icgraph.png" border="0" usemap="#d2/d11/group__udp_ga6f3d90ff7fcd39b3767b1ebc8eb58e1a_icgraph" alt=""/></div>
<map name="d2/d11/group__udp_ga6f3d90ff7fcd39b3767b1ebc8eb58e1a_icgraph" id="d2/d11/group__udp_ga6f3d90ff7fcd39b3767b1ebc8eb58e1a_icgraph">
<area shape="rect" id="node2" href="../../d5/dc2/structThread_1_1Cli_1_1Interpreter.html#ac3a6d19e1230529b3970e31ca7324373" title="This method interprets a CLI command. " alt="" coords="214,61,369,100"/>
<area shape="rect" id="node3" href="../../dd/dce/classThread_1_1Cli_1_1Console.html#ab5454035d54e21e0e780335eddf7ca7d" title="This method sets a callback that is called when console has some output. " alt="" coords="423,5,566,44"/>
<area shape="rect" id="node4" href="../../db/def/group__uart.html#ga2aec94bad212a6bd72bc82fe310eaca2" title="The UART driver calls this method to notify OpenThread that bytes have been received. " alt="" coords="426,68,563,93"/>
<area shape="rect" id="node5" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#ab23c737fe108c24331f40d024d5f446a" title="This method starts the CLI server. " alt="" coords="417,117,571,143"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="gaafd3057272c0b42c69aa7d35956f5c92"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> otSendUdp </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="../../da/dfd/structotUdpSocket.html">otUdpSocket</a> *&#160;</td>
          <td class="paramname"><em>aSocket</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d4/d7c/group__messages.html#ga461fb1347aeb99b1d4aab520915e121e">otMessage</a>&#160;</td>
          <td class="paramname"><em>aMessage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="../../dd/d76/structotMessageInfo.html">otMessageInfo</a> *&#160;</td>
          <td class="paramname"><em>aMessageInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send a UDP/IPv6 message. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">aSocket</td><td>A pointer to a UDP socket structure. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessage</td><td>A pointer to a message buffer. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">aMessageInfo</td><td>A pointer to a message info structure.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="../../d2/d11/group__udp.html#ga830b1fac9ad667bbedc0e68da91e70aa" title="Allocate a new message buffer for sending a UDP message. ">otNewUdpMessage</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gaa44b7d374d87e6f3624c275913676954" title="Open a UDP/IPv6 socket. ">otOpenUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#ga2957568d7098fc442abaadad77daabee" title="Close a UDP/IPv6 socket. ">otCloseUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gabbff7369b8794d597a5afd188e171ec0" title="Bind a UDP/IPv6 socket. ">otBindUdpSocket</a> </dd>
<dd>
<a class="el" href="../../d2/d11/group__udp.html#gaafd3057272c0b42c69aa7d35956f5c92" title="Send a UDP/IPv6 message. ">otSendUdp</a> </dd></dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d11/group__udp_gaafd3057272c0b42c69aa7d35956f5c92_icgraph.png" border="0" usemap="#d2/d11/group__udp_gaafd3057272c0b42c69aa7d35956f5c92_icgraph" alt=""/></div>
<map name="d2/d11/group__udp_gaafd3057272c0b42c69aa7d35956f5c92_icgraph" id="d2/d11/group__udp_gaafd3057272c0b42c69aa7d35956f5c92_icgraph">
<area shape="rect" id="node2" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#a50e5829bd74bf2845d8313575e2dd15c" title="This method delivers raw characters to the client. " alt="" coords="141,12,307,37"/>
<area shape="rect" id="node3" href="../../dc/df5/classThread_1_1Cli_1_1Udp.html#ab8ac2489d2049ef5880c77ac1cdc639f" title="This method delivers formatted output to the client. " alt="" coords="355,5,521,44"/>
</map>
</div>
</p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:35 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
